#include "aes.h"

#if 0
#define DEBUG
#endif

#ifdef DEBUG
#include <stdio.h>
static void _debug_print(const char* title,
		unsigned char data[4][4]) {
	int i;
	printf("%s",title);
	for(i=0;i<16;i++)printf("%02x",(int)data[i%4][i/4]);
	puts("");
}
#define debug_print _debug_print
#define debug_printf printf
#else
#define debug_print
#define debug_printf
#endif

static unsigned char mul(unsigned char a,unsigned char b) {
	int kakezan;
	unsigned char result;
	int temp;
	int i;
	kakezan=a;
	result=0;
	if(b&1)result^=kakezan;
	for(i=1;i<8;i++) {
		kakezan<<=1;
		if(kakezan>0xff) {
			kakezan&=0xff;
			kakezan^=0x1b;
		}
		if(b&(1<<i))result^=kakezan;
	}
	return result;
}

static void SubWord(unsigned char word[4]) {
	static const unsigned char table[256]={
		0x63,0x7c,0x77,0x7b,0xf2,0x6b,0x6f,0xc5,0x30,0x01,0x67,0x2b,0xfe,0xd7,0xab,0x76,
		0xca,0x82,0xc9,0x7d,0xfa,0x59,0x47,0xf0,0xad,0xd4,0xa2,0xaf,0x9c,0xa4,0x72,0xc0,
		0xb7,0xfd,0x93,0x26,0x36,0x3f,0xf7,0xcc,0x34,0xa5,0xe5,0xf1,0x71,0xd8,0x31,0x15,
		0x04,0xc7,0x23,0xc3,0x18,0x96,0x05,0x9a,0x07,0x12,0x80,0xe2,0xeb,0x27,0xb2,0x75,
		0x09,0x83,0x2c,0x1a,0x1b,0x6e,0x5a,0xa0,0x52,0x3b,0xd6,0xb3,0x29,0xe3,0x2f,0x84,
		0x53,0xd1,0x00,0xed,0x20,0xfc,0xb1,0x5b,0x6a,0xcb,0xbe,0x39,0x4a,0x4c,0x58,0xcf,
		0xd0,0xef,0xaa,0xfb,0x43,0x4d,0x33,0x85,0x45,0xf9,0x02,0x7f,0x50,0x3c,0x9f,0xa8,
		0x51,0xa3,0x40,0x8f,0x92,0x9d,0x38,0xf5,0xbc,0xb6,0xda,0x21,0x10,0xff,0xf3,0xd2,
		0xcd,0x0c,0x13,0xec,0x5f,0x97,0x44,0x17,0xc4,0xa7,0x7e,0x3d,0x64,0x5d,0x19,0x73,
		0x60,0x81,0x4f,0xdc,0x22,0x2a,0x90,0x88,0x46,0xee,0xb8,0x14,0xde,0x5e,0x0b,0xdb,
		0xe0,0x32,0x3a,0x0a,0x49,0x06,0x24,0x5c,0xc2,0xd3,0xac,0x62,0x91,0x95,0xe4,0x79,
		0xe7,0xc8,0x37,0x6d,0x8d,0xd5,0x4e,0xa9,0x6c,0x56,0xf4,0xea,0x65,0x7a,0xae,0x08,
		0xba,0x78,0x25,0x2e,0x1c,0xa6,0xb4,0xc6,0xe8,0xdd,0x74,0x1f,0x4b,0xbd,0x8b,0x8a,
		0x70,0x3e,0xb5,0x66,0x48,0x03,0xf6,0x0e,0x61,0x35,0x57,0xb9,0x86,0xc1,0x1d,0x9e,
		0xe1,0xf8,0x98,0x11,0x69,0xd9,0x8e,0x94,0x9b,0x1e,0x87,0xe9,0xce,0x55,0x28,0xdf,
		0x8c,0xa1,0x89,0x0d,0xbf,0xe6,0x42,0x68,0x41,0x99,0x2d,0x0f,0xb0,0x54,0xbb,0x16
	};
	word[0]=table[word[0]];
	word[1]=table[word[1]];
	word[2]=table[word[2]];
	word[3]=table[word[3]];
}

static void SubBytes(unsigned char state[4][4]) {
	SubWord(state[0]);
	SubWord(state[1]);
	SubWord(state[2]);
	SubWord(state[3]);
}

static void ShiftRows(unsigned char state[4][4]) {
	unsigned char temp;
	unsigned char temp2;
	temp=state[1][0];
	state[1][0]=state[1][1];
	state[1][1]=state[1][2];
	state[1][2]=state[1][3];
	state[1][3]=temp;
	temp=state[2][0];
	temp2=state[2][1];
	state[2][0]=state[2][2];
	state[2][1]=state[2][3];
	state[2][2]=temp;
	state[2][3]=temp2;
	temp=state[3][3];
	state[3][3]=state[3][2];
	state[3][2]=state[3][1];
	state[3][1]=state[3][0];
	state[3][0]=temp;
}

static void MixColumns(unsigned char state[4][4]) {
	unsigned char temp[4];
	int i;
	for(i=0;i<4;i++) {
		temp[0]=state[0][i];
		temp[1]=state[1][i];
		temp[2]=state[2][i];
		temp[3]=state[3][i];
		state[0][i]=mul(0x02,temp[0])^
			mul(0x03,temp[1])^
			temp[2]^
			temp[3];
		state[1][i]=temp[0]^
			mul(0x02,temp[1])^
			mul(0x03,temp[2])^
			temp[3];
		state[2][i]=temp[0]^
			temp[1]^
			mul(0x02,temp[2])^
			mul(0x03,temp[3]);
		state[3][i]=mul(0x03,temp[0])^
			temp[1]^
			temp[2]^
			mul(0x02,temp[3]);
	}
}

static void AddRoundKey(unsigned char state[4][4],
		unsigned char key[][4],int round) {
	int i;
	for(i=0;i<4;i++) {
		state[0][i]^=key[round*4+i][0];
		state[1][i]^=key[round*4+i][1];
		state[2][i]^=key[round*4+i][2];
		state[3][i]^=key[round*4+i][3];
	}
}

static void InvSubBytes(unsigned char state[4][4]) {
	static const unsigned char table[256]={
		0x52,0x09,0x6a,0xd5,0x30,0x36,0xa5,0x38,0xbf,0x40,0xa3,0x9e,0x81,0xf3,0xd7,0xfb,
		0x7c,0xe3,0x39,0x82,0x9b,0x2f,0xff,0x87,0x34,0x8e,0x43,0x44,0xc4,0xde,0xe9,0xcb,
		0x54,0x7b,0x94,0x32,0xa6,0xc2,0x23,0x3d,0xee,0x4c,0x95,0x0b,0x42,0xfa,0xc3,0x4e,
		0x08,0x2e,0xa1,0x66,0x28,0xd9,0x24,0xb2,0x76,0x5b,0xa2,0x49,0x6d,0x8b,0xd1,0x25,
		0x72,0xf8,0xf6,0x64,0x86,0x68,0x98,0x16,0xd4,0xa4,0x5c,0xcc,0x5d,0x65,0xb6,0x92,
		0x6c,0x70,0x48,0x50,0xfd,0xed,0xb9,0xda,0x5e,0x15,0x46,0x57,0xa7,0x8d,0x9d,0x84,
		0x90,0xd8,0xab,0x00,0x8c,0xbc,0xd3,0x0a,0xf7,0xe4,0x58,0x05,0xb8,0xb3,0x45,0x06,
		0xd0,0x2c,0x1e,0x8f,0xca,0x3f,0x0f,0x02,0xc1,0xaf,0xbd,0x03,0x01,0x13,0x8a,0x6b,
		0x3a,0x91,0x11,0x41,0x4f,0x67,0xdc,0xea,0x97,0xf2,0xcf,0xce,0xf0,0xb4,0xe6,0x73,
		0x96,0xac,0x74,0x22,0xe7,0xad,0x35,0x85,0xe2,0xf9,0x37,0xe8,0x1c,0x75,0xdf,0x6e,
		0x47,0xf1,0x1a,0x71,0x1d,0x29,0xc5,0x89,0x6f,0xb7,0x62,0x0e,0xaa,0x18,0xbe,0x1b,
		0xfc,0x56,0x3e,0x4b,0xc6,0xd2,0x79,0x20,0x9a,0xdb,0xc0,0xfe,0x78,0xcd,0x5a,0xf4,
		0x1f,0xdd,0xa8,0x33,0x88,0x07,0xc7,0x31,0xb1,0x12,0x10,0x59,0x27,0x80,0xec,0x5f,
		0x60,0x51,0x7f,0xa9,0x19,0xb5,0x4a,0x0d,0x2d,0xe5,0x7a,0x9f,0x93,0xc9,0x9c,0xef,
		0xa0,0xe0,0x3b,0x4d,0xae,0x2a,0xf5,0xb0,0xc8,0xeb,0xbb,0x3c,0x83,0x53,0x99,0x61,
		0x17,0x2b,0x04,0x7e,0xba,0x77,0xd6,0x26,0xe1,0x69,0x14,0x63,0x55,0x21,0x0c,0x7d
	};
	int i,j;
	for(i=0;i<4;i++) {
		for(j=0;j<4;j++) {
			state[i][j]=table[state[i][j]];
		}
	}
}

static void InvShiftRows(unsigned char state[4][4]) {
	unsigned char temp;
	unsigned char temp2;
	temp=state[1][3];
	state[1][3]=state[1][2];
	state[1][2]=state[1][1];
	state[1][1]=state[1][0];
	state[1][0]=temp;
	temp=state[2][2];
	temp2=state[2][3];
	state[2][2]=state[2][0];
	state[2][3]=state[2][1];
	state[2][0]=temp;
	state[2][1]=temp2;
	temp=state[3][0];
	state[3][0]=state[3][1];
	state[3][1]=state[3][2];
	state[3][2]=state[3][3];
	state[3][3]=temp;
}
static void InvMixColumns(unsigned char state[4][4]) {
	unsigned char temp[4];
	int i;
	for(i=0;i<4;i++) {
		temp[0]=state[0][i];
		temp[1]=state[1][i];
		temp[2]=state[2][i];
		temp[3]=state[3][i];
		state[0][i]=mul(0x0e,temp[0])^
			mul(0x0b,temp[1])^
			mul(0x0d,temp[2])^
			mul(0x09,temp[3]);
		state[1][i]=mul(0x09,temp[0])^
			mul(0x0e,temp[1])^
			mul(0x0b,temp[2])^
			mul(0x0d,temp[3]);
		state[2][i]=mul(0x0d,temp[0])^
			mul(0x09,temp[1])^
			mul(0x0e,temp[2])^
			mul(0x0b,temp[3]);
		state[3][i]=mul(0x0b,temp[0])^
			mul(0x0d,temp[1])^
			mul(0x09,temp[2])^
			mul(0x0e,temp[3]);
	}
}

static void KeyExpansion(unsigned char key[][4],int length) {
	static const unsigned char Rcon[10]={
		0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x1b,0x36
	};
	unsigned char temp[4];
	unsigned char temp2;
	int maxi=0;
	int i;
	switch(length) {
		case 4:maxi=44;break;
		case 6:maxi=52;break;
		case 8:maxi=60;break;
	}
	for(i=length;i<maxi;i++) {
		temp[0]=key[i-1][0];
		temp[1]=key[i-1][1];
		temp[2]=key[i-1][2];
		temp[3]=key[i-1][3];
		if(i%length==0) {
			/*RotWord*/
			temp2=temp[0];
			temp[0]=temp[1];
			temp[1]=temp[2];
			temp[2]=temp[3];
			temp[3]=temp2;
			/*SubWord*/
			SubWord(temp);
			/*XOR Rcon*/
			temp[0]^=Rcon[i/length-1];
		} else if(length>6 && (i-4)%length==0) {
			/*SubWord*/
			SubWord(temp);
		}
		key[i][0]=temp[0]^key[i-length][0];
		key[i][1]=temp[1]^key[i-length][1];
		key[i][2]=temp[2]^key[i-length][2];
		key[i][3]=temp[3]^key[i-length][3];
	}
}

void aes_encript(unsigned char* output,
		const unsigned char* input,
		const unsigned char* key,
		int type) {
	unsigned char state[4][4];
	unsigned char ekey[60][4];
	int length;
	int roundnum;
	int round;
	int i;
	if(type!=AES_128 && type!=AES_192 && type!=AES_256)return;
	state[0][0]=input[0];state[1][0]=input[1];
	state[2][0]=input[2];state[3][0]=input[3];
	state[0][1]=input[4];state[1][1]=input[5];
	state[2][1]=input[6];state[3][1]=input[7];
	state[0][2]=input[8];state[1][2]=input[9];
	state[2][2]=input[10];state[3][2]=input[11];
	state[0][3]=input[12];state[1][3]=input[13];
	state[2][3]=input[14];state[3][3]=input[15];
	switch(type) {
		case AES_128:length=4;roundnum=10;break;
		case AES_192:length=6;roundnum=12;break;
		case AES_256:length=8;roundnum=14;break;
	}
	for(i=0;i<length;i++) {
		ekey[i][0]=key[i*4];
		ekey[i][1]=key[i*4+1];
		ekey[i][2]=key[i*4+2];
		ekey[i][3]=key[i*4+3];
	}
	KeyExpansion(ekey,length);
	AddRoundKey(state,ekey,0);
	debug_print("AddRoundKey:",state);
	for(i=1;i<roundnum;i++) {
		debug_printf("Round %d\n",i);
		SubBytes(state);
		debug_print("SubBytes:",state);
		ShiftRows(state);
		debug_print("ShiftRows:",state);
		MixColumns(state);
		debug_print("MixColumns:",state);
		AddRoundKey(state,ekey,i);
		debug_print("AddRoundKey:",state);
	}
	debug_printf("Round end\n");
	SubBytes(state);
	debug_print("SubBytes:",state);
	ShiftRows(state);
	debug_print("ShiftRows:",state);
	AddRoundKey(state,ekey,roundnum);
	debug_print("AddRoundKey:",state);
	output[0]=state[0][0];output[1]=state[1][0];
	output[2]=state[2][0];output[3]=state[3][0];
	output[4]=state[0][1];output[5]=state[1][1];
	output[6]=state[2][1];output[7]=state[3][1];
	output[8]=state[0][2];output[9]=state[1][2];
	output[10]=state[2][2];output[11]=state[3][2];
	output[12]=state[0][3];output[13]=state[1][3];
	output[14]=state[2][3];output[15]=state[3][3];
}

void aes_decript(unsigned char* output,
		const unsigned char* input,
		const unsigned char* key,
		int type) {
	unsigned char state[4][4];
	unsigned char ekey[60][4];
	int length;
	int round;
	int roundnum;
	int i;
	if(type!=AES_128 && type!=AES_192 && type!=AES_256)return;
	state[0][0]=input[0];state[1][0]=input[1];
	state[2][0]=input[2];state[3][0]=input[3];
	state[0][1]=input[4];state[1][1]=input[5];
	state[2][1]=input[6];state[3][1]=input[7];
	state[0][2]=input[8];state[1][2]=input[9];
	state[2][2]=input[10];state[3][2]=input[11];
	state[0][3]=input[12];state[1][3]=input[13];
	state[2][3]=input[14];state[3][3]=input[15];
	switch(type) {
		case AES_128:length=4;roundnum=10;break;
		case AES_192:length=6;roundnum=12;break;
		case AES_256:length=8;roundnum=14;break;
	}
	for(i=0;i<length;i++) {
		ekey[i][0]=key[i*4];
		ekey[i][1]=key[i*4+1];
		ekey[i][2]=key[i*4+2];
		ekey[i][3]=key[i*4+3];
	}
	KeyExpansion(ekey,length);
	AddRoundKey(state,ekey,roundnum);
	debug_print("AddRoundKey:",state);
	for(i=roundnum-1;i>=1;i--) {
		debug_printf("Round %d\n",i);
		InvShiftRows(state);
		debug_print("InvShiftRows:",state);
		InvSubBytes(state);
		debug_print("InvSubBytes:",state);
		AddRoundKey(state,ekey,i);
		debug_print("AddRoundKey:",state);
		InvMixColumns(state);
		debug_print("InvMixColumns:",state);
	}
	InvSubBytes(state);
	debug_print("InvSubBytes:",state);
	InvShiftRows(state);
	debug_print("InvShiftRows:",state);
	AddRoundKey(state,ekey,0);
	debug_print("AddRoundKey:",state);
	output[0]=state[0][0];output[1]=state[1][0];
	output[2]=state[2][0];output[3]=state[3][0];
	output[4]=state[0][1];output[5]=state[1][1];
	output[6]=state[2][1];output[7]=state[3][1];
	output[8]=state[0][2];output[9]=state[1][2];
	output[10]=state[2][2];output[11]=state[3][2];
	output[12]=state[0][3];output[13]=state[1][3];
	output[14]=state[2][3];output[15]=state[3][3];
}
