#ifndef _BMPIO_H_
#define _BMPIO_H_

#include <windows.h>

#define getBmpWidth(bmp) ((bmp)->width)
#define getBmpHeight(bmp) ((bmp)->height)
#define getBmpXY(bmp,x,y) ((bmp)->data[(y)*((bmp)->width)+(x)])

enum {
	BMP_FULL,
	BMP_256,
	BMP_16,
	BMP_MONO
};

enum {
	COLORTABLE_DEFAULT,
	COLORTABLE_AUTODETECT,
	COLORTABLE_INPUT
};

typedef struct {
	unsigned char b;
	unsigned char g;
	unsigned char r;
} rgb_t;

typedef struct {
	int width;
	int height;
	rgb_t* data;
} bmp_t;

#ifdef __cplusplus
extern "C" {
#endif

bmp_t* bmpMake(int width,int height);
bmp_t* bmpCopy(const bmp_t* source);
bmp_t* bmpLoad(const char* filename);
int bmpErrorDiffusion(bmp_t* bmp,int type);
int bmpSave(const bmp_t* bmp,const char* filename,int type,int cttype,const rgb_t* ct);
bmp_t* bmpLoadFromHandle(HDC hDC,HBITMAP hBmp);
HBITMAP bmpSaveToHandle(HDC hDC,const bmp_t* bmp);
void bmpFree(bmp_t* bmp);

#ifdef __cplusplus
}
#endif

#endif /* _BMPIO_H_ */
